
DIR = 'datatypes/'

def get_all(force=False):
    if get_all.cache and not force:
        return get_all.cache

    from os import listdir
    from os.path import isfile, join
    import json
    get_all.cache = []
    files = [ f for f in listdir(DIR) if isfile(join(DIR,f)) ]
    for file in files:
        with open(join(DIR,file)) as f:
            try:
                data=json.loads(f.read())
                get_all.cache.append(data)
            except ValueError:
                pass    # if a file can't be read, do nothing
    return get_all()
get_all.cache = None

def get_rest(type):
    for data in get_all():
        if data['root-type'] == type:
            return data['REST-API']

def get_data_types():
    result = []
    for data in get_all():
        result.append(data['root-type'])
    return result

def get_fields(type):
    for data in get_all():
        if data['root-type'] == type:
            return data['fields']

def get_labels(type):
    result = []
    fields = get_fields(type)
    if fields is not None:
        for f in fields:
            result.append(f['label'])
    return result

def get_field_label(type, key):
    fields = get_fields(type)
    for f in fields:
        if "key" in f and f["key"] == key:
            return f["label"]
    return key

def get_fields_required(type):
    result = []
    fields = get_fields(type)
    if fields is not None:
        for f in fields:
            result.append((f['label'],f['required']))
    return result

def get_fields_from_labels(labels, type):
    result=[]
    fields = get_fields(type)
    if fields is not None:
        for l in labels:
            for f in fields:
                if f['label'] == l:
                    result.append(f['field'])
                    break
    return result
